﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {

  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public abstract class Expression {
    private readonly string stringRepresentation;

    protected Expression(string stringRepresentation) {
      this.stringRepresentation = stringRepresentation;
    }

    public string StringRepresentation { get { return this.stringRepresentation; } }

    public abstract void Eval(IPushGpInterpreter interpreter);

    public override string ToString() {
      return this.stringRepresentation;
    }
  }
}